// gpio.h 2013-01-29 18:40
//
// (c) 2013 Markus Weber, Nuernberg
// GNU GPL v2 (see Readme.txt)
//
// This source code file adds general purpose i/o functions
// to USBasp version "guloprog" for ATtiny85 microcontroller.
//
// Include this file in USBasp's main.c directly before function
// definition of usbFunctionSetup() and place three function calls
// at these positions:
// if(data[1]>='A' && data[1]<='D') len= gpio_control(); else
//                      in function usbFunctionSetup(), right before
//                      this line: if (data[1] == USBASP_FUNC_CONNECT)
// gpio_ini():          initialization, before entering main loop
// gpio_main():         somewhere in main loop

//#include <inttypes.h>
//#include <stdlib.h>
//#include <string.h>
//#include <stdio.h>
//#include <ctype.h>
//#include <unistd.h>
//#include <signal.h>
//#include <usb.h>

typedef enum {false= 0,true= 1} bool;



static inline uint8_t gpio_control() {
  // process a USB control message which has been received from host;
  // data[1]: i/o pin ('A'..'D'), must be in this range;
  // data[2]: control value for this pin;
  //          0: set pin to Low;
  //          1..99: activate PWM for this pin, 1..99 % High;
  //          100: set pin to High;
  //          -1: switch pin to input;
  //          -2: switch pin to input, activate pull-up resistor;
  //          -6: just get input values for this pin;
  // return: 4;
  // in case data[2]==-6, the replyBuffer[] is set to these values:
  // replyBuffer[0]: 0: pin is Low; 1: pin is High;
  // replyBuffer[1]: 0;
  // replyBuffer[2]: ADC value of the requested pin, low byte
  // replyBuffer[3]: ADC value of the requested pin, high byte
  uint8_t iopin,pin;
    // i/o pin A: PB4 (pin 3, no resistor)
    // i/o pin B: PB3 (pin 2)
    // i/o pin C: PB5 (pin 1, weak output)
    // i/o pin D: PB0 (pin 5, no ADC)
  int8_t newval;

  // translate i/o pin letter to port pin number
  iopin= data[1]-'A';
  if(iopin==0) pin= 4;
  else if(--iopin==0) pin= 3;
  else if(--iopin==0) pin= 5;
  else pin= 0;

  newval= data[2];
  if(newval==-6) {  // no output, just get input values





    }  // no output, just get input values





  }  // gpio_control()



static inline void gpio_ini() {
  // initialize general purpose i/o funtions;


  }  // gpio_ini()



static inline void gpio_main() {
  // care about PWM output (soft PWM) and read ADC results;


  }  // gpio_main()




